require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_M68K_ASM_H_)) {
    eval 'sub _M68K_ASM_H_ () {1;}' unless defined(&_M68K_ASM_H_);
    eval 'sub __IMMEDIATE () {1;}' unless defined(&__IMMEDIATE);
    if(defined(&__PIC__)) {
	eval 'sub PIC_PLT {
	    my($name) = @_;
    	    eval q($name@ &PLTPC);
	}' unless defined(&PIC_PLT);
	if(defined(&__mcoldfire__)) {
	    eval 'sub LEA_LCL {
	        my($name,$reg) = @_;
    		eval q( &movl  &__IMMEDIATE $name - .,$reg ;  &lea (-6,% &pc,$reg),$reg);
	    }' unless defined(&LEA_LCL);
	    eval 'sub GOT_SETUP {
	        my($reg) = @_;
    		eval q( &movl  &__IMMEDIATE  &_GLOBAL_OFFSET_TABLE_@ &GOTPC,$reg ;  &lea (-6,% &pc,$reg),$reg);
	    }' unless defined(&GOT_SETUP);
	} else {
	    eval 'sub LEA_LCL {
	        my($name,$reg) = @_;
    		eval q( &lea ($name,% &pc),$reg);
	    }' unless defined(&LEA_LCL);
	    eval 'sub GOT_SETUP {
	        my($reg) = @_;
    		eval q( &lea ( &_GLOBAL_OFFSET_TABLE_@ &GOTPC,% &pc),$reg);
	    }' unless defined(&GOT_SETUP);
	}
    } else {
	eval 'sub PIC_PLT {
	    my($name) = @_;
    	    eval q($name);
	}' unless defined(&PIC_PLT);
	eval 'sub LEA_LCL {
	    my($name,$reg) = @_;
    	    eval q( &movl  &__IMMEDIATE $name,$reg);
	}' unless defined(&LEA_LCL);
	eval 'sub GOT_SETUP {
	    my($reg) = @_;
    	    eval q();
	}' unless defined(&GOT_SETUP);
    }
    if((defined(&__STDC__) ? &__STDC__ : undef)) {
	eval 'sub _C_LABEL {
	    my($name) = @_;
    	    eval q($name);
	}' unless defined(&_C_LABEL);
    } else {
	eval 'sub _C_LABEL {
	    my($name) = @_;
    	    eval q($name);
	}' unless defined(&_C_LABEL);
    }
    eval 'sub _ASM_LABEL {
        my($name) = @_;
	    eval q($name);
    }' unless defined(&_ASM_LABEL);
    eval 'sub _ENTRY {
        my($name) = @_;
	    eval q(. &text; . &even; . &globl $name; . &type $name,@ &function; $name:);
    }' unless defined(&_ENTRY);
    eval 'sub END {
        my($name) = @_;
	    eval q(. &size $name,.-$name);
    }' unless defined(&END);
    eval 'sub MCOUNT_ENTRY () { &__mcount;}' unless defined(&MCOUNT_ENTRY);
    if(defined(&GPROF)) {
	eval 'sub _PROF_PROLOG () { &link % &a6,0;  &jbsr  &MCOUNT_ENTRY;  &unlk % &a6;}' unless defined(&_PROF_PROLOG);
    } else {
	eval 'sub _PROF_PROLOG () {1;}' unless defined(&_PROF_PROLOG);
    }
    eval 'sub ENTRY {
        my($name) = @_;
	    eval q( &_ENTRY( &_C_LABEL($name))  &_PROF_PROLOG);
    }' unless defined(&ENTRY);
    eval 'sub ASENTRY {
        my($name) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($name))  &_PROF_PROLOG);
    }' unless defined(&ASENTRY);
    eval 'sub ENTRY_NOPROFILE {
        my($name) = @_;
	    eval q( &_ENTRY( &_C_LABEL($name)));
    }' unless defined(&ENTRY_NOPROFILE);
    eval 'sub ASENTRY_NOPROFILE {
        my($name) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($name)));
    }' unless defined(&ASENTRY_NOPROFILE);
    if(defined(&PROF)) {
	eval 'sub ALTENTRY {
	    my($name, $rname) = @_;
    	    eval q( &ENTRY($name);  &jra $rname+12);
	}' unless defined(&ALTENTRY);
    } else {
	eval 'sub ALTENTRY {
	    my($name, $rname) = @_;
    	    eval q( &_ENTRY( &_C_LABEL($name)));
	}' unless defined(&ALTENTRY);
    }
    eval 'sub RCSID {
        my($x) = @_;
	    eval q(. &pushsection \\".ident\\",\\"MS\\",@ &progbits,1; . &asciz $x; . &popsection);
    }' unless defined(&RCSID);
    eval 'sub GLOBAL {
        my($x) = @_;
	    eval q(. &globl  &_C_LABEL($x) ;  &_C_LABEL($x):);
    }' unless defined(&GLOBAL);
    eval 'sub ASGLOBAL {
        my($x) = @_;
	    eval q(. &globl  &_ASM_LABEL($x) ;  &_ASM_LABEL($x):);
    }' unless defined(&ASGLOBAL);
    eval 'sub LOCAL {
        my($x) = @_;
	    eval q( &_C_LABEL($x):);
    }' unless defined(&LOCAL);
    eval 'sub ASLOCAL {
        my($x) = @_;
	    eval q( &_ASM_LABEL($x):);
    }' unless defined(&ASLOCAL);
    eval 'sub BSS {
        my($name, $size) = @_;
	    eval q(. &comm  &_C_LABEL($name),$size);
    }' unless defined(&BSS);
    eval 'sub ASBSS {
        my($name, $size) = @_;
	    eval q(. &comm  &_ASM_LABEL($name),$size);
    }' unless defined(&ASBSS);
    if(defined(&__mcoldfire__)) {
	eval 'sub INTERRUPT_SAVEREG () { &lea -16(% &sp),% &sp;  &moveml 0xc0c0,(% &sp);}' unless defined(&INTERRUPT_SAVEREG);
	eval 'sub INTERRUPT_RESTOREREG () { &moveml (% &sp),0x303;  &lea 16(% &sp),% &sp;}' unless defined(&INTERRUPT_RESTOREREG);
    } else {
	eval 'sub INTERRUPT_SAVEREG () { &moveml 0xc0c0,-(% &sp);}' unless defined(&INTERRUPT_SAVEREG);
	eval 'sub INTERRUPT_RESTOREREG () { &moveml (% &sp)+,0x303;}' unless defined(&INTERRUPT_RESTOREREG);
    }
    if(defined(&_KERNEL)) {
	eval 'sub PANIC {
	    my($x) = @_;
    	    eval q( &pea 9 &f ;  &jbsr  &_C_LABEL( &panic) ; 9: . &asciz $x ; . &even);
	}' unless defined(&PANIC);
	eval 'sub CPUINFO_INCREMENT {
	    my($n) = @_;
    	    eval q( &lea  &_C_LABEL( &cpu_info_store)+($n)+4,% &a1;  ($addq->{l})	1,(% &a1);  ($clr->{l})	% &d0;  ($move->{l})	-(% &a1),% &d1;  ($addx->{l})	% &d0,% &d1;  ($move->{l})	% &d1,(% &a1));
	}' unless defined(&CPUINFO_INCREMENT);
	eval 'sub CPUINFO_ADD {
	    my($n, $addend) = @_;
    	    eval q( &lea  &_C_LABEL( &cpu_info_store)+($n)+4,% &a1;  ($add->{l})	$addend,(% &a1);  ($clr->{l})	% &d0;  ($move->{l})	-(% &a1),% &d1;  ($addx->{l})	% &d0,% &d1;  ($move->{l})	% &d1,(% &a1));
	}' unless defined(&CPUINFO_ADD);
    }
    eval 'sub VECTOR {
        my($x) = @_;
	    eval q(. &long _C_LABEL($x));
    }' unless defined(&VECTOR);
    eval 'sub ASVECTOR {
        my($x) = @_;
	    eval q(. &long _ASM_LABEL($x));
    }' unless defined(&ASVECTOR);
    eval 'sub VECTOR_UNUSED () {.\'long 0\';}' unless defined(&VECTOR_UNUSED);
    eval 'sub WEAK_ALIAS {
        my($alias,$sym) = @_;
	    eval q(. &weak $alias; $alias = $sym);
    }' unless defined(&WEAK_ALIAS);
    eval 'sub STRONG_ALIAS {
        my($alias,$sym) = @_;
	    eval q(. &globl $alias; $alias = $sym);
    }' unless defined(&STRONG_ALIAS);
    if(defined(&__STDC__)) {
	eval 'sub WARN_REFERENCES {
	    my($sym,$msg) = @_;
    	    eval q(. &pushsection . ($gnu->{warning}).  $sym; . &ascii $msg; . &popsection);
	}' unless defined(&WARN_REFERENCES);
    } else {
	eval 'sub WARN_REFERENCES {
	    my($sym,$msg) = @_;
    	    eval q(. &pushsection . ($gnu->{warning}). $sym; . &ascii $msg; . &popsection);
	}' unless defined(&WARN_REFERENCES);
    }
    if(defined(&__mc68010__)) {
	eval 'sub EXTBL {
	    my($reg) = @_;
    	    eval q( &extw $reg ;  &extl $reg);
	}' unless defined(&EXTBL);
    } else {
	eval 'sub EXTBL {
	    my($reg) = @_;
    	    eval q( &extbl $reg);
	}' unless defined(&EXTBL);
    }
}
1;
