require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_M68K_CPU_H_)) {
    eval 'sub _M68K_CPU_H_ () {1;}' unless defined(&_M68K_CPU_H_);
    require 'm68k/m68k.ph';
    eval 'sub PMMU_LVLMASK () {0x7;}' unless defined(&PMMU_LVLMASK);
    eval 'sub PMMU_INV () {0x400;}' unless defined(&PMMU_INV);
    eval 'sub PMMU_WP () {0x800;}' unless defined(&PMMU_WP);
    eval 'sub PMMU_ALV () {0x1000;}' unless defined(&PMMU_ALV);
    eval 'sub PMMU_SO () {0x2000;}' unless defined(&PMMU_SO);
    eval 'sub PMMU_LV () {0x4000;}' unless defined(&PMMU_LV);
    eval 'sub PMMU_BE () {0x8000;}' unless defined(&PMMU_BE);
    eval 'sub PMMU_FAULT () {( &PMMU_WP| &PMMU_INV);}' unless defined(&PMMU_FAULT);
    eval 'sub MMU40_RES () {0x1;}' unless defined(&MMU40_RES);
    eval 'sub MMU40_TTR () {0x2;}' unless defined(&MMU40_TTR);
    eval 'sub MMU40_WP () {0x4;}' unless defined(&MMU40_WP);
    eval 'sub MMU40_MOD () {0x10;}' unless defined(&MMU40_MOD);
    eval 'sub MMU40_CMMASK () {0x60;}' unless defined(&MMU40_CMMASK);
    eval 'sub MMU40_SUP () {0x80;}' unless defined(&MMU40_SUP);
    eval 'sub MMU40_U0 () {0x100;}' unless defined(&MMU40_U0);
    eval 'sub MMU40_U1 () {0x200;}' unless defined(&MMU40_U1);
    eval 'sub MMU40_GLB () {0x400;}' unless defined(&MMU40_GLB);
    eval 'sub MMU40_BE () {0x800;}' unless defined(&MMU40_BE);
    eval 'sub FC_USERD () {1;}' unless defined(&FC_USERD);
    eval 'sub FC_USERP () {2;}' unless defined(&FC_USERP);
    eval 'sub FC_PURGE () {3;}' unless defined(&FC_PURGE);
    eval 'sub FC_SUPERD () {5;}' unless defined(&FC_SUPERD);
    eval 'sub FC_SUPERP () {6;}' unless defined(&FC_SUPERP);
    eval 'sub FC_CPU () {7;}' unless defined(&FC_CPU);
    eval 'sub IC_ENABLE () {0x1;}' unless defined(&IC_ENABLE);
    eval 'sub IC_FREEZE () {0x2;}' unless defined(&IC_FREEZE);
    eval 'sub IC_CE () {0x4;}' unless defined(&IC_CE);
    eval 'sub IC_CLR () {0x8;}' unless defined(&IC_CLR);
    eval 'sub IC_BE () {0x10;}' unless defined(&IC_BE);
    eval 'sub DC_ENABLE () {0x100;}' unless defined(&DC_ENABLE);
    eval 'sub DC_FREEZE () {0x200;}' unless defined(&DC_FREEZE);
    eval 'sub DC_CE () {0x400;}' unless defined(&DC_CE);
    eval 'sub DC_CLR () {0x800;}' unless defined(&DC_CLR);
    eval 'sub DC_BE () {0x1000;}' unless defined(&DC_BE);
    eval 'sub DC_WA () {0x2000;}' unless defined(&DC_WA);
    eval 'sub IC40_ENABLE () {0x8000;}' unless defined(&IC40_ENABLE);
    eval 'sub DC40_ENABLE () {0x80000000;}' unless defined(&DC40_ENABLE);
    eval 'sub DC60_NAD () {0x40000000;}' unless defined(&DC60_NAD);
    eval 'sub DC60_ESB () {0x20000000;}' unless defined(&DC60_ESB);
    eval 'sub DC60_DPI () {0x10000000;}' unless defined(&DC60_DPI);
    eval 'sub DC60_FOC () {0x8000000;}' unless defined(&DC60_FOC);
    eval 'sub IC60_EBC () {0x800000;}' unless defined(&IC60_EBC);
    eval 'sub IC60_CABC () {0x400000;}' unless defined(&IC60_CABC);
    eval 'sub IC60_CUBC () {0x200000;}' unless defined(&IC60_CUBC);
    eval 'sub IC60_NAI () {0x4000;}' unless defined(&IC60_NAI);
    eval 'sub IC60_FIC () {0x2000;}' unless defined(&IC60_FIC);
    eval 'sub CACHE_ON () {( &DC_WA| &DC_BE| &DC_CLR| &DC_ENABLE| &IC_BE| &IC_CLR| &IC_ENABLE);}' unless defined(&CACHE_ON);
    eval 'sub CACHE_OFF () {( &DC_CLR| &IC_CLR);}' unless defined(&CACHE_OFF);
    eval 'sub CACHE_CLR () {( &CACHE_ON);}' unless defined(&CACHE_CLR);
    eval 'sub IC_CLEAR () {( &DC_WA| &DC_BE| &DC_ENABLE| &IC_BE| &IC_CLR| &IC_ENABLE);}' unless defined(&IC_CLEAR);
    eval 'sub DC_CLEAR () {( &DC_WA| &DC_BE| &DC_CLR| &DC_ENABLE| &IC_BE| &IC_ENABLE);}' unless defined(&DC_CLEAR);
    eval 'sub CACHE40_ON () {( &IC40_ENABLE| &DC40_ENABLE);}' unless defined(&CACHE40_ON);
    eval 'sub CACHE40_OFF () {(0x);}' unless defined(&CACHE40_OFF);
    eval 'sub CACHE60_ON () {( &CACHE40_ON| &IC60_CABC| &IC60_EBC| &DC60_ESB);}' unless defined(&CACHE60_ON);
    eval 'sub CACHE60_OFF () {( &CACHE40_OFF| &IC60_CABC);}' unless defined(&CACHE60_OFF);
    eval 'sub CACHELINE_SIZE () {16;}' unless defined(&CACHELINE_SIZE);
    eval 'sub CACHELINE_MASK () {( &CACHELINE_SIZE - 1);}' unless defined(&CACHELINE_MASK);
    eval 'sub CPU_CONSDEV () {1;}' unless defined(&CPU_CONSDEV);
    eval 'sub CPU_ROOT_DEVICE () {2;}' unless defined(&CPU_ROOT_DEVICE);
    eval 'sub CPU_BOOTED_KERNEL () {3;}' unless defined(&CPU_BOOTED_KERNEL);
    if(defined(&_KERNEL) || defined(&_KMEMUSER)) {
	require 'sys/cpu_data.ph';
    }
    if(defined(&_KERNEL)) {
	eval 'sub curcpu () {
	    eval q(( &cpu_info_store));
	}' unless defined(&curcpu);
	eval 'sub cpu_number () {
	    eval q(0);
	}' unless defined(&cpu_number);
	eval 'sub LWP_PC {
	    my($l) = @_;
    	    eval q((((($l)-> ($l_md->{md_regs})))-> &tf_pc));
	}' unless defined(&LWP_PC);
    }
}
1;
