require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_M68K_FENV_H_)) {
    eval 'sub _M68K_FENV_H_ () {1;}' unless defined(&_M68K_FENV_H_);
    require 'sys/stdint.ph';
    require 'm68k/float.ph';
    require 'm68k/fpreg.ph';
    eval 'sub FE_INEXACT () { &FPSR_AINEX;}' unless defined(&FE_INEXACT);
    eval 'sub FE_DIVBYZERO () { &FPSR_ADZ;}' unless defined(&FE_DIVBYZERO);
    eval 'sub FE_UNDERFLOW () { &FPSR_AUNFL;}' unless defined(&FE_UNDERFLOW);
    eval 'sub FE_OVERFLOW () { &FPSR_AOVFL;}' unless defined(&FE_OVERFLOW);
    eval 'sub FE_INVALID () { &FPSR_AIOP;}' unless defined(&FE_INVALID);
    eval 'sub FE_ALL_EXCEPT () {( &FE_INEXACT |  &FE_DIVBYZERO |  &FE_UNDERFLOW |  &FE_OVERFLOW |  &FE_INVALID);}' unless defined(&FE_ALL_EXCEPT);
    eval 'sub FE_TONEAREST () { &FPCR_NEAR;}' unless defined(&FE_TONEAREST);
    eval 'sub FE_TOWARDZERO () { &FPCR_ZERO;}' unless defined(&FE_TOWARDZERO);
    eval 'sub FE_DOWNWARD () { &FPCR_MINF;}' unless defined(&FE_DOWNWARD);
    eval 'sub FE_UPWARD () { &FPCR_PINF;}' unless defined(&FE_UPWARD);
    eval 'sub _ROUND_MASK () {( &FE_TONEAREST |  &FE_TOWARDZERO |  &FE_DOWNWARD |  &FE_UPWARD);}' unless defined(&_ROUND_MASK);
    if(defined(&__HAVE_68881__)) {
	unless(defined(&__fenv_static)) {
	    eval 'sub __fenv_static () { &static;}' unless defined(&__fenv_static);
	}
	eval 'sub FE_DFL_ENV () {(( &fenv_t *) -1);}' unless defined(&FE_DFL_ENV);
	eval 'sub __get_fpcr {
	    my($__fpcr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_fpcr);
	eval 'sub __set_fpcr {
	    my($__fpcr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__set_fpcr);
	eval 'sub __get_fpsr {
	    my($__fpsr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_fpsr);
	eval 'sub __set_fpsr {
	    my($__fpsr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__set_fpsr);
	eval 'sub __fmul {
	    my($__s, $__t, $__d) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__fmul);
	eval 'sub __fdiv {
	    my($__s, $__t, $__d) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__fdiv);
	eval 'sub __fetox {
	    my($__s, $__t, $__d) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__fetox);
	eval 'sub __fgetenv {
	    my($__envp) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__fgetenv);
	eval 'sub __fsetenv {
	    my($__envp) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__fsetenv);
	if( &__GNUC_PREREQ__(8, 0)) {
	}
	if( &__GNUC_PREREQ__(8, 0)) {
	}
	if(defined(&_NETBSD_SOURCE) || defined(&_GNU_SOURCE)) {
	}
    }
}
1;
